## apngasm-3.1.6.tar.gz

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(APNGASM)


ADD_SUBDIRECTORY(${PROJECT_SOURCE_DIR}/lib)
ADD_SUBDIRECTORY(${PROJECT_SOURCE_DIR}/cli)
ADD_SUBDIRECTORY(${PROJECT_SOURCE_DIR}/test)


# Create package command
IF(UNIX OR APPLE)
  ADD_CUSTOM_TARGET(
    package
    COMMAND ${CMAKE_MAKE_PROGRAM}
    COMMAND ${CMAKE_MAKE_PROGRAM} package-lib
    COMMAND ${CMAKE_MAKE_PROGRAM} package-cli
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
  )
ENDIF(UNIX OR APPLE)

IF(WIN32)
  ADD_CUSTOM_TARGET(
    package
    COMMAND cd lib/package
    COMMAND ${CMAKE_COMMAND} .
    COMMAND ${CMAKE_MAKE_PROGRAM} PACKAGE.vcxproj /p:Configuration=$(Configuration)
    COMMAND cd ../../cli/package
    COMMAND ${CMAKE_COMMAND} .
    COMMAND ${CMAKE_MAKE_PROGRAM} PACKAGE.vcxproj /p:Configuration=$(Configuration)
    WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
  )
ENDIF(WIN32)
